Commits

camlspotter  committed 06b7456

1.0-orig

  • Participants
  • Branches 1.0-orig

Comments (0)

Files changed (12)

+dbm.cmo: dbm.cmi
+dbm.cmx: dbm.cmi
+dbm.cmi:
+Release 1.0 (2011-11-22)
+	- First public release, based on the sources taken from OCaml 3.12.1
+This Library is distributed under the terms of the GNU Library General
+Public License version 2 (included below).
+
+As a special exception to the GNU Library General Public License, you
+may link, statically or dynamically, a "work that uses the Library"
+with a publicly distributed version of the Library to produce an
+executable file containing portions of the Library, and distribute
+that executable file under terms of your choice, without any of the
+additional requirements listed in clause 6 of the GNU Library General
+Public License.  By "a publicly distributed version of the Library",
+we mean either the unmodified Library as distributed by INRIA, or a
+modified version of the Library that is distributed under the
+conditions defined in clause 3 of the GNU Library General Public
+License.  This exception does not however invalidate any other reasons
+why the executable file might be covered by the GNU Library General
+Public License.
+
+----------------------------------------------------------------------
+
+                  GNU LIBRARY GENERAL PUBLIC LICENSE
+                       Version 2, June 1991
+
+ Copyright (C) 1991 Free Software Foundation, Inc.
+ 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+[This is the first released version of the library GPL.  It is
+ numbered 2 because it goes with version 2 of the ordinary GPL.]
+
+                            Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+Licenses are intended to guarantee your freedom to share and change
+free software--to make sure the software is free for all its users.
+
+  This license, the Library General Public License, applies to some
+specially designated Free Software Foundation software, and to any
+other libraries whose authors decide to use it.  You can use it for
+your libraries, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if
+you distribute copies of the library, or if you modify it.
+
+  For example, if you distribute copies of the library, whether gratis
+or for a fee, you must give the recipients all the rights that we gave
+you.  You must make sure that they, too, receive or can get the source
+code.  If you link a program with the library, you must provide
+complete object files to the recipients so that they can relink them
+with the library, after making changes to the library and recompiling
+it.  And you must show them these terms so they know their rights.
+
+  Our method of protecting your rights has two steps: (1) copyright
+the library, and (2) offer you this license which gives you legal
+permission to copy, distribute and/or modify the library.
+
+  Also, for each distributor's protection, we want to make certain
+that everyone understands that there is no warranty for this free
+library.  If the library is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original
+version, so that any problems introduced by others will not reflect on
+the original authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that companies distributing free
+software will individually obtain patent licenses, thus in effect
+transforming the program into proprietary software.  To prevent this,
+we have made it clear that any patent must be licensed for everyone's
+free use or not licensed at all.
+
+  Most GNU software, including some libraries, is covered by the ordinary
+GNU General Public License, which was designed for utility programs.  This
+license, the GNU Library General Public License, applies to certain
+designated libraries.  This license is quite different from the ordinary
+one; be sure to read it in full, and don't assume that anything in it is
+the same as in the ordinary license.
+
+  The reason we have a separate public license for some libraries is that
+they blur the distinction we usually make between modifying or adding to a
+program and simply using it.  Linking a program with a library, without
+changing the library, is in some sense simply using the library, and is
+analogous to running a utility program or application program.  However, in
+a textual and legal sense, the linked executable is a combined work, a
+derivative of the original library, and the ordinary General Public License
+treats it as such.
+
+  Because of this blurred distinction, using the ordinary General
+Public License for libraries did not effectively promote software
+sharing, because most developers did not use the libraries.  We
+concluded that weaker conditions might promote sharing better.
+
+  However, unrestricted linking of non-free programs would deprive the
+users of those programs of all benefit from the free status of the
+libraries themselves.  This Library General Public License is intended to
+permit developers of non-free programs to use free libraries, while
+preserving your freedom as a user of such programs to change the free
+libraries that are incorporated in them.  (We have not seen how to achieve
+this as regards changes in header files, but we have achieved it as regards
+changes in the actual functions of the Library.)  The hope is that this
+will lead to faster development of free libraries.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.  Pay close attention to the difference between a
+"work based on the library" and a "work that uses the library".  The
+former contains code derived from the library, while the latter only
+works together with the library.
+
+  Note that it is possible for a library to be covered by the ordinary
+General Public License rather than by this special one.
+
+                  GNU LIBRARY GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License Agreement applies to any software library which
+contains a notice placed by the copyright holder or other authorized
+party saying it may be distributed under the terms of this Library
+General Public License (also called "this License").  Each licensee is
+addressed as "you".
+
+  A "library" means a collection of software functions and/or data
+prepared so as to be conveniently linked with application programs
+(which use some of those functions and data) to form executables.
+
+  The "Library", below, refers to any such software library or work
+which has been distributed under these terms.  A "work based on the
+Library" means either the Library or any derivative work under
+copyright law: that is to say, a work containing the Library or a
+portion of it, either verbatim or with modifications and/or translated
+straightforwardly into another language.  (Hereinafter, translation is
+included without limitation in the term "modification".)
+
+  "Source code" for a work means the preferred form of the work for
+making modifications to it.  For a library, complete source code means
+all the source code for all modules it contains, plus any associated
+interface definition files, plus the scripts used to control compilation
+and installation of the library.
+
+  Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running a program using the Library is not restricted, and output from
+such a program is covered only if its contents constitute a work based
+on the Library (independent of the use of the Library in a tool for
+writing it).  Whether that is true depends on what the Library does
+and what the program that uses the Library does.
+
+  1. You may copy and distribute verbatim copies of the Library's
+complete source code as you receive it, in any medium, provided that
+you conspicuously and appropriately publish on each copy an
+appropriate copyright notice and disclaimer of warranty; keep intact
+all the notices that refer to this License and to the absence of any
+warranty; and distribute a copy of this License along with the
+Library.
+
+  You may charge a fee for the physical act of transferring a copy,
+and you may at your option offer warranty protection in exchange for a
+fee.
+
+  2. You may modify your copy or copies of the Library or any portion
+of it, thus forming a work based on the Library, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) The modified work must itself be a software library.
+
+    b) You must cause the files modified to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    c) You must cause the whole of the work to be licensed at no
+    charge to all third parties under the terms of this License.
+
+    d) If a facility in the modified Library refers to a function or a
+    table of data to be supplied by an application program that uses
+    the facility, other than as an argument passed when the facility
+    is invoked, then you must make a good faith effort to ensure that,
+    in the event an application does not supply such function or
+    table, the facility still operates, and performs whatever part of
+    its purpose remains meaningful.
+
+    (For example, a function in a library to compute square roots has
+    a purpose that is entirely well-defined independent of the
+    application.  Therefore, Subsection 2d requires that any
+    application-supplied function or table used by this function must
+    be optional: if the application does not supply it, the square
+    root function must still compute square roots.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Library,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Library, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote
+it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Library.
+
+In addition, mere aggregation of another work not based on the Library
+with the Library (or with a work based on the Library) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may opt to apply the terms of the ordinary GNU General Public
+License instead of this License to a given copy of the Library.  To do
+this, you must alter all the notices that refer to this License, so
+that they refer to the ordinary GNU General Public License, version 2,
+instead of to this License.  (If a newer version than version 2 of the
+ordinary GNU General Public License has appeared, then you can specify
+that version instead if you wish.)  Do not make any other change in
+these notices.
+
+  Once this change is made in a given copy, it is irreversible for
+that copy, so the ordinary GNU General Public License applies to all
+subsequent copies and derivative works made from that copy.
+
+  This option is useful when you wish to copy part of the code of
+the Library into a program that is not a library.
+
+  4. You may copy and distribute the Library (or a portion or
+derivative of it, under Section 2) in object code or executable form
+under the terms of Sections 1 and 2 above provided that you accompany
+it with the complete corresponding machine-readable source code, which
+must be distributed under the terms of Sections 1 and 2 above on a
+medium customarily used for software interchange.
+
+  If distribution of object code is made by offering access to copy
+from a designated place, then offering equivalent access to copy the
+source code from the same place satisfies the requirement to
+distribute the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  5. A program that contains no derivative of any portion of the
+Library, but is designed to work with the Library by being compiled or
+linked with it, is called a "work that uses the Library".  Such a
+work, in isolation, is not a derivative work of the Library, and
+therefore falls outside the scope of this License.
+
+  However, linking a "work that uses the Library" with the Library
+creates an executable that is a derivative of the Library (because it
+contains portions of the Library), rather than a "work that uses the
+library".  The executable is therefore covered by this License.
+Section 6 states terms for distribution of such executables.
+
+  When a "work that uses the Library" uses material from a header file
+that is part of the Library, the object code for the work may be a
+derivative work of the Library even though the source code is not.
+Whether this is true is especially significant if the work can be
+linked without the Library, or if the work is itself a library.  The
+threshold for this to be true is not precisely defined by law.
+
+  If such an object file uses only numerical parameters, data
+structure layouts and accessors, and small macros and small inline
+functions (ten lines or less in length), then the use of the object
+file is unrestricted, regardless of whether it is legally a derivative
+work.  (Executables containing this object code plus portions of the
+Library will still fall under Section 6.)
+
+  Otherwise, if the work is a derivative of the Library, you may
+distribute the object code for the work under the terms of Section 6.
+Any executables containing that work also fall under Section 6,
+whether or not they are linked directly with the Library itself.
+
+  6. As an exception to the Sections above, you may also compile or
+link a "work that uses the Library" with the Library to produce a
+work containing portions of the Library, and distribute that work
+under terms of your choice, provided that the terms permit
+modification of the work for the customer's own use and reverse
+engineering for debugging such modifications.
+
+  You must give prominent notice with each copy of the work that the
+Library is used in it and that the Library and its use are covered by
+this License.  You must supply a copy of this License.  If the work
+during execution displays copyright notices, you must include the
+copyright notice for the Library among them, as well as a reference
+directing the user to the copy of this License.  Also, you must do one
+of these things:
+
+    a) Accompany the work with the complete corresponding
+    machine-readable source code for the Library including whatever
+    changes were used in the work (which must be distributed under
+    Sections 1 and 2 above); and, if the work is an executable linked
+    with the Library, with the complete machine-readable "work that
+    uses the Library", as object code and/or source code, so that the
+    user can modify the Library and then relink to produce a modified
+    executable containing the modified Library.  (It is understood
+    that the user who changes the contents of definitions files in the
+    Library will not necessarily be able to recompile the application
+    to use the modified definitions.)
+
+    b) Accompany the work with a written offer, valid for at
+    least three years, to give the same user the materials
+    specified in Subsection 6a, above, for a charge no more
+    than the cost of performing this distribution.
+
+    c) If distribution of the work is made by offering access to copy
+    from a designated place, offer equivalent access to copy the above
+    specified materials from the same place.
+
+    d) Verify that the user has already received a copy of these
+    materials or that you have already sent this user a copy.
+
+  For an executable, the required form of the "work that uses the
+Library" must include any data and utility programs needed for
+reproducing the executable from it.  However, as a special exception,
+the source code distributed need not include anything that is normally
+distributed (in either source or binary form) with the major
+components (compiler, kernel, and so on) of the operating system on
+which the executable runs, unless that component itself accompanies
+the executable.
+
+  It may happen that this requirement contradicts the license
+restrictions of other proprietary libraries that do not normally
+accompany the operating system.  Such a contradiction means you cannot
+use both them and the Library together in an executable that you
+distribute.
+
+  7. You may place library facilities that are a work based on the
+Library side-by-side in a single library together with other library
+facilities not covered by this License, and distribute such a combined
+library, provided that the separate distribution of the work based on
+the Library and of the other library facilities is otherwise
+permitted, and provided that you do these two things:
+
+    a) Accompany the combined library with a copy of the same work
+    based on the Library, uncombined with any other library
+    facilities.  This must be distributed under the terms of the
+    Sections above.
+
+    b) Give prominent notice with the combined library of the fact
+    that part of it is a work based on the Library, and explaining
+    where to find the accompanying uncombined form of the same work.
+
+  8. You may not copy, modify, sublicense, link with, or distribute
+the Library except as expressly provided under this License.  Any
+attempt otherwise to copy, modify, sublicense, link with, or
+distribute the Library is void, and will automatically terminate your
+rights under this License.  However, parties who have received copies,
+or rights, from you under this License will not have their licenses
+terminated so long as such parties remain in full compliance.
+
+  9. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Library or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Library (or any work based on the
+Library), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Library or works based on it.
+
+  10. Each time you redistribute the Library (or any work based on the
+Library), the recipient automatically receives a license from the
+original licensor to copy, distribute, link with or modify the Library
+subject to these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  11. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Library at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Library by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Library.
+
+If any portion of this section is held invalid or unenforceable under any
+particular circumstance, the balance of the section is intended to apply,
+and the section as a whole is intended to apply in other circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  12. If the distribution and/or use of the Library is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Library under this License may add
+an explicit geographical distribution limitation excluding those countries,
+so that distribution is permitted only in or among countries not thus
+excluded.  In such case, this License incorporates the limitation as if
+written in the body of this License.
+
+  13. The Free Software Foundation may publish revised and/or new
+versions of the Library General Public License from time to time.
+Such new versions will be similar in spirit to the present version,
+but may differ in detail to address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Library
+specifies a version number of this License which applies to it and
+"any later version", you have the option of following the terms and
+conditions either of that version or of any later version published by
+the Free Software Foundation.  If the Library does not specify a
+license version number, you may choose any version ever published by
+the Free Software Foundation.
+
+  14. If you wish to incorporate parts of the Library into other free
+programs whose distribution conditions are incompatible with these,
+write to the author to ask for permission.  For software which is
+copyrighted by the Free Software Foundation, write to the Free
+Software Foundation; we sometimes make exceptions for this.  Our
+decision will be guided by the two goals of preserving the free status
+of all derivatives of our free software and of promoting the sharing
+and reuse of software generally.
+
+                            NO WARRANTY
+
+  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO
+WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.
+EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR
+OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY
+KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE
+IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE
+LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME
+THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+
+  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
+WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY
+AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU
+FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR
+CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE
+LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING
+RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A
+FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF
+SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
+DAMAGES.
+
+                     END OF TERMS AND CONDITIONS
+
+     Appendix: How to Apply These Terms to Your New Libraries
+
+  If you develop a new library, and you want it to be of the greatest
+possible use to the public, we recommend making it free software that
+everyone can redistribute and change.  You can do so by permitting
+redistribution under these terms (or, alternatively, under the terms of the
+ordinary General Public License).
+
+  To apply these terms, attach the following notices to the library.  It is
+safest to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least the
+"copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the library's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Library General Public
+    License as published by the Free Software Foundation; either
+    version 2 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Library General Public License for more details.
+
+    You should have received a copy of the GNU Library General Public
+    License along with this library; if not, write to the Free
+    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
+    MA 02111-1307, USA
+
+Also add information on how to contact you by electronic and paper mail.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the library, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the
+  library `Frob' (a library for tweaking knobs) written by James Random Hacker.
+
+  <signature of Ty Coon>, 1 April 1990
+  Ty Coon, President of Vice
+
+That's all there is to it!
+description = "Access to GDBM/NDBM databases"
+requires = ""
+version = "1.0"
+archive(byte) = "dbm.cma"
+archive(native) = "dbm.cmxa"
+#########################################################################
+#                                                                       #
+#                                 CamlDBM                               #
+#                                                                       #
+#            Xavier Leroy, projet Gallium, INRIA Rocquencourt           #
+#                                                                       #
+#   Copyright 2011 Institut National de Recherche en Informatique et    #
+#   en Automatique.  All rights reserved.  This file is distributed     #
+#   under the terms of the GNU Library General Public License, with     #
+#   the special exception on linking described in file ../../LICENSE.   #
+#                                                                       #
+#########################################################################
+
+include Makefile.config
+
+OCAMLC=ocamlc
+OCAMLOPT=ocamlopt
+OCAMLMKLIB=ocamlmklib
+OCAMLDEP=ocamldep
+OCAMLRUN=ocamlrun
+O=o
+A=a
+SO=so
+LIBDIR=`ocamlc -where`
+STUBLIBDIR=$(LIBDIR)/stublibs
+
+
+all: libcamldbm.$(A) dbm.cma dbm.cmxa dbm.cmxs 
+
+dbm.cma: dbm.cmo
+	$(OCAMLMKLIB) -o dbm -oc camldbm -linkall dbm.cmo $(DBM_LINK)
+
+dbm.cmxa: dbm.cmx
+	$(OCAMLMKLIB) -o dbm -oc camldbm -linkall dbm.cmx $(DBM_LINK)
+
+dbm.cmxs: dbm.cmxa libcamldbm.$(A)
+	$(OCAMLOPT) -shared -o dbm.cmxs -I . dbm.cmxa
+
+libcamldbm.$(A): cldbm.$(O)
+	$(OCAMLMKLIB) -oc camldbm cldbm.$(O) $(DBM_LINK)
+
+.SUFFIXES: .ml .mli .cmi .cmo .cmx .$(O)
+
+.mli.cmi:
+	$(OCAMLC) -c $(COMPFLAGS) $<
+
+.ml.cmo:
+	$(OCAMLC) -c $(COMPFLAGS) $<
+
+.ml.cmx:
+	$(OCAMLOPT) -c $(COMPFLAGS) $<
+
+.c.$(O):
+	$(OCAMLC) -c -ccopt "$(DBM_INCLUDE)" -ccopt "$(DBM_DEFINES)" $<
+
+depend:
+	$(OCAMLDEP) *.ml *.mli > .depend
+
+install::
+	if test -f dllcamldbm.$(SO); then cp dllcamldbm.$(SO) $(STUBLIBDIR)/; fi 
+	cp libcamldbm.$(A) $(LIBDIR)/
+	cd $(LIBDIR) && ranlib libcamldbm.$(A)
+	cp dbm.cma dbm.cmxa dbm.cmi dbm.mli $(LIBDIR)/
+	cp dbm.$(A) $(LIBDIR)/
+	cd $(LIBDIR) && ranlib dbm.$(A)
+	if test -f dbm.cmxs; then cp dbm.cmxs $(LIBDIR)/; fi
+
+clean::
+	rm -f *.cm* *.$(O) *.$(A) *.$(SO)
+
+testdbm.byte: dbm.cma testdbm.ml
+	$(OCAMLC) -o $@ dbm.cma testdbm.ml
+
+testdbm.opt: dbm.cmxa testdbm.ml
+	$(OCAMLOPT) -ccopt -L. -o $@ dbm.cmxa testdbm.ml
+
+clean::
+	rm -f testdbm.byte testdbm.opt testdatabase.*
+
+test: testdbm.byte testdbm.opt
+	rm -f testdatabase.*
+	ocamlrun -I . ./testdbm.byte
+	rm -f testdatabase.*
+	./testdbm.opt
+	rm -f testdatabase.*
+	
+
+include .depend

File Makefile.config

+OCAML_STDLIB=/usr/local/ocaml-3.12/lib/ocaml
+DBM_INCLUDES=
+DBM_LINK=-lgdbm_compat -lgdbm
+DBM_DEFINES=-DDBM_USES_GDBM_NDBM
+                        The CamlDBM library
+
+
+OVERVIEW:
+
+  This OCaml library is a binding to the NDBM/GDBM Unix "databases".
+
+  See the file dbm.mli for documentation of the programming inteface.
+
+  This library used to be included in the standard OCaml distribution.
+  This is the standalone distribution of this library, with the same
+  functionalities.
+
+
+REQUIREMENTS:
+
+  - OCaml
+  - Either the GDBM library or any NDBM-compatible library
+    (make sure to install the development files as well,
+     e.g. the package libgdbm-dev for Debian or Ubuntu).
+
+
+INSTALLATION:
+
+  - Run the "configure" script by typing
+       ./configure
+
+  - Build the library:
+       make all
+
+  - Test the library:
+       make test
+
+  - Install the library:
+       sudo make install
+
+
+USAGE:
+
+  In bytecode:
+     ocamlc dbm.cma <other bytecode files>
+
+  In native code:
+     ocamlopt dbm.cmxa <other bytecode files>
+
+
+LICENSE:
+
+  This Library is distributed under the terms of the GNU Library General
+  Public License version 2, with a special exception allowing
+  unconstrained static linking.  See file LICENSE for details.
+
+
+     
+/***********************************************************************/
+/*                                                                     */
+/*                                OCaml                                */
+/*                                                                     */
+/*            Francois Rouaix, projet Cristal, INRIA Rocquencourt      */
+/*                                                                     */
+/*  Copyright 1996 Institut National de Recherche en Informatique et   */
+/*  en Automatique.  All rights reserved.  This file is distributed    */
+/*  under the terms of the GNU Library General Public License, with    */
+/*  the special exception on linking described in file ../../LICENSE.  */
+/*                                                                     */
+/***********************************************************************/
+
+/* $Id: cldbm.c 11156 2011-07-27 14:17:02Z doligez $ */
+
+#include <string.h>
+#include <fcntl.h>
+#include <caml/mlvalues.h>
+#include <caml/alloc.h>
+#include <caml/memory.h>
+#include <caml/fail.h>
+#include <caml/callback.h>
+
+#ifdef DBM_USES_GDBM_NDBM
+#include <gdbm-ndbm.h>
+#else
+#include <ndbm.h>
+#endif
+
+/* Quite close to sys_open_flags, but we need RDWR */
+static int dbm_open_flags[] = {
+  O_RDONLY, O_WRONLY, O_RDWR, O_CREAT
+};
+
+static void raise_dbm (char *errmsg) Noreturn;
+
+static void raise_dbm(char *errmsg)
+{
+  static value * dbm_exn = NULL;
+  if (dbm_exn == NULL)
+    dbm_exn = caml_named_value("dbmerror");
+  raise_with_string(*dbm_exn, errmsg);
+}
+
+#define DBM_val(v) *((DBM **) &Field(v, 0))
+
+static value alloc_dbm(DBM * db)
+{
+  value res = alloc_small(1, Abstract_tag);
+  DBM_val(res) = db;
+  return res;
+}
+
+static DBM * extract_dbm(value vdb)
+{
+  if (DBM_val(vdb) == NULL) raise_dbm("DBM has been closed");
+  return DBM_val(vdb);
+}
+
+/* Dbm.open : string -> Sys.open_flag list -> int -> t */
+value caml_dbm_open(value vfile, value vflags, value vmode) /* ML */
+{
+  char *file = String_val(vfile);
+  int flags = convert_flag_list(vflags, dbm_open_flags);
+  int mode = Int_val(vmode);
+  DBM *db = dbm_open(file,flags,mode);
+
+  if (db == NULL)
+    raise_dbm("Can't open file");
+  else
+    return (alloc_dbm(db));
+}
+
+/* Dbm.close: t -> unit */
+value caml_dbm_close(value vdb)       /* ML */
+{
+  dbm_close(extract_dbm(vdb));
+  DBM_val(vdb) = NULL;
+  return Val_unit;
+}
+
+/* Dbm.fetch: t -> string -> string */
+value caml_dbm_fetch(value vdb, value vkey)  /* ML */
+{
+  datum key,answer;
+  key.dptr = String_val(vkey);
+  key.dsize = string_length(vkey);
+  answer = dbm_fetch(extract_dbm(vdb), key);
+  if (answer.dptr) {
+    value res = alloc_string(answer.dsize);
+    memmove (String_val (res), answer.dptr, answer.dsize);
+    return res;
+  }
+  else raise_not_found();
+}
+
+value caml_dbm_insert(value vdb, value vkey, value vcontent) /* ML */
+{
+  datum key, content;
+
+  key.dptr = String_val(vkey);
+  key.dsize = string_length(vkey);
+  content.dptr = String_val(vcontent);
+  content.dsize = string_length(vcontent);
+
+  switch(dbm_store(extract_dbm(vdb), key, content, DBM_INSERT)) {
+  case 0:
+    return Val_unit;
+  case 1:                       /* DBM_INSERT and already existing */
+    raise_dbm("Entry already exists");
+  default:
+    raise_dbm("dbm_store failed");
+  }
+}
+
+value caml_dbm_replace(value vdb, value vkey, value vcontent) /* ML */
+{
+  datum key, content;
+
+  key.dptr = String_val(vkey);
+  key.dsize = string_length(vkey);
+  content.dptr = String_val(vcontent);
+  content.dsize = string_length(vcontent);
+
+  switch(dbm_store(extract_dbm(vdb), key, content, DBM_REPLACE)) {
+  case 0:
+    return Val_unit;
+  default:
+    raise_dbm("dbm_store failed");
+  }
+}
+
+value caml_dbm_delete(value vdb, value vkey)         /* ML */
+{
+  datum key;
+  key.dptr = String_val(vkey);
+  key.dsize = string_length(vkey);
+
+  if (dbm_delete(extract_dbm(vdb), key) < 0)
+    raise_dbm("dbm_delete");
+  else return Val_unit;
+}
+
+value caml_dbm_firstkey(value vdb)            /* ML */
+{
+  datum key = dbm_firstkey(extract_dbm(vdb));
+
+  if (key.dptr) {
+    value res = alloc_string(key.dsize);
+    memmove (String_val (res), key.dptr, key.dsize);
+    return res;
+  }
+  else raise_not_found();
+}
+
+value caml_dbm_nextkey(value vdb)             /* ML */
+{
+  datum key = dbm_nextkey(extract_dbm(vdb));
+
+  if (key.dptr) {
+    value res = alloc_string(key.dsize);
+    memmove (String_val (res), key.dptr, key.dsize);
+    return res;
+  }
+  else raise_not_found();
+}
+#! /bin/sh
+
+#########################################################################
+#                                                                       #
+#                                 CamlDBM                               #
+#                                                                       #
+#            Xavier Leroy, projet Gallium, INRIA Rocquencourt           #
+#                                                                       #
+#   Copyright 2011 Institut National de Recherche en Informatique et    #
+#   en Automatique.  All rights reserved.  This file is distributed     #
+#   under the terms of the GNU Library General Public License, with     #
+#   the special exception on linking described in file LICENSE.         #
+#                                                                       #
+#########################################################################
+
+version=`ocamlc -version`
+
+if test $? -ne 0; then
+  echo "ocamlc not found, aborting."
+  exit 2
+fi
+
+echo "Configuring for OCaml version $version"
+echo
+
+stdlib=`ocamlc -where`
+
+hasgot() {
+  rm -f hasgot.c
+  (echo "#include <$2>"
+   echo 'int main() {'
+   echo '  (void) dbm_open("foo", 0, 0);'
+   echo '  return 0;'
+   echo '}') > hasgot.c
+  ${CC:-cc} -I$1 -o hasgot.exe hasgot.c $3 $4
+  res=$?
+  rm -f hasgot.c hasgot.exe
+  return $?
+}
+
+dbm_include="not found"
+dbm_link="not found"
+dbm_defines=""
+
+for dir in /usr/include /usr/include/db1 /usr/include/gdbm; do
+  if test -f $dir/ndbm.h; then
+    dbm_include=$dir
+    if hasgot $dir ndbm.h; then
+      dbm_link=""
+    elif hasgot $dir ndbm.h -lndbm; then
+      dbm_link="-lndbm"
+    elif hasgot $dir ndbm.h -ldb1; then
+      dbm_link="-ldb1"
+    elif hasgot $dir ndbm.h -lgdbm; then
+      dbm_link="-lgdbm"
+    elif hasgot $dir ndbm.h -lgdbm_compat -lgdbm; then
+      dbm_link="-lgdbm_compat -lgdbm"
+    fi
+    break
+  fi
+  if test -f $dir/gdbm-ndbm.h; then
+    dbm_include=$dir
+    dbm_defines="-DDBM_USES_GDBM_NDBM"
+    if hasgot $dir gdbm-ndbm.h -lgdbm_compat -lgdbm; then
+      dbm_link="-lgdbm_compat -lgdbm"
+    fi
+    break
+  fi
+done
+if test "$dbm_include" = "not found" || test "$dbm_link" = "not found"; then
+  echo "NDBM not found, the \"camldbm\" library cannot be built."
+  exit 2
+fi
+
+echo "Configuration for the \"camldbm\" library:"
+echo "        headers found in ......... $dbm_include"
+echo "        options for compiling .... $dbm_defines"
+echo "        options for linking ...... $dbm_link"
+echo
+echo "Configuration successful"
+echo
+
+if test "$dbm_include" = "/usr/include"; then
+  dbm_include=""
+else
+  dbm_include="-I$dbm_include"
+fi
+
+echo "OCAML_STDLIB=$stdlib" > Makefile.config
+echo "DBM_INCLUDES=$dbm_include" >> Makefile.config
+echo "DBM_LINK=$dbm_link" >> Makefile.config
+echo "DBM_DEFINES=$dbm_defines" >> Makefile.config
+
+(***********************************************************************)
+(*                                                                     *)
+(*                                OCaml                                *)
+(*                                                                     *)
+(*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        *)
+(*                                                                     *)
+(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
+(*  en Automatique.  All rights reserved.  This file is distributed    *)
+(*  under the terms of the GNU Library General Public License, with    *)
+(*  the special exception on linking described in file ../../LICENSE.  *)
+(*                                                                     *)
+(***********************************************************************)
+
+(* $Id: dbm.ml 11156 2011-07-27 14:17:02Z doligez $ *)
+
+type t
+
+type open_flag =
+   Dbm_rdonly | Dbm_wronly | Dbm_rdwr | Dbm_create
+
+type dbm_flag =
+   DBM_INSERT
+ | DBM_REPLACE
+
+exception Dbm_error of string
+
+external raw_opendbm : string -> open_flag list -> int -> t
+              = "caml_dbm_open"
+
+let opendbm file flags mode =
+  try
+    raw_opendbm file flags mode
+  with Dbm_error msg ->
+    raise(Dbm_error("Can't open file " ^ file))
+
+ (* By exporting opendbm as val, we are sure to link in this
+    file (we must register the exception). Since t is abstract, programs
+    have to call it in order to do anything *)
+
+external close : t -> unit = "caml_dbm_close"
+external find : t -> string -> string = "caml_dbm_fetch"
+external add : t -> string -> string -> unit = "caml_dbm_insert"
+external replace : t -> string -> string -> unit = "caml_dbm_replace"
+external remove : t -> string -> unit = "caml_dbm_delete"
+external firstkey : t -> string = "caml_dbm_firstkey"
+external nextkey : t -> string = "caml_dbm_nextkey"
+
+let _ = Callback.register_exception "dbmerror" (Dbm_error "")
+
+(* Usual iterator *)
+let iter f t =
+  let rec walk = function
+      None -> ()
+    | Some k ->
+        f k (find t k);
+        walk (try Some(nextkey t) with Not_found -> None)
+  in
+  walk (try Some(firstkey t) with Not_found -> None)
+(***********************************************************************)
+(*                                                                     *)
+(*                                CamlDBM                              *)
+(*                                                                     *)
+(*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        *)
+(*                                                                     *)
+(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
+(*  en Automatique.  All rights reserved.  This file is distributed    *)
+(*  under the terms of the GNU Library General Public License, with    *)
+(*  the special exception on linking described in file ../../LICENSE.  *)
+(*                                                                     *)
+(***********************************************************************)
+
+(* $Id: dbm.mli 11156 2011-07-27 14:17:02Z doligez $ *)
+
+(** Interface to the NDBM database. *)
+
+type t
+(** The type of file descriptors opened on NDBM databases. *)
+
+
+type open_flag =
+    Dbm_rdonly
+  | Dbm_wronly
+  | Dbm_rdwr
+  | Dbm_create
+(** Flags for opening a database (see {!Dbm.opendbm}). *)
+
+
+exception Dbm_error of string
+(** Raised by the following functions when an error is encountered. *)
+
+val opendbm : string -> open_flag list -> int -> t
+(** Open a descriptor on an NDBM database. The first argument is
+   the name of the database (without the [.dir] and [.pag] suffixes).
+   The second argument is a list of flags: [Dbm_rdonly] opens
+   the database for reading only, [Dbm_wronly] for writing only,
+   [Dbm_rdwr] for reading and writing; [Dbm_create] causes the
+   database to be created if it does not already exist.
+   The third argument is the permissions to give to the database
+   files, if the database is created. *)
+
+external close : t -> unit = "caml_dbm_close"
+(** Close the given descriptor. *)
+
+external find : t -> string -> string = "caml_dbm_fetch"
+(** [find db key] returns the data associated with the given
+   [key] in the database opened for the descriptor [db].
+   Raise [Not_found] if the [key] has no associated data. *)
+
+external add : t -> string -> string -> unit = "caml_dbm_insert"
+(** [add db key data] inserts the pair ([key], [data]) in
+   the database [db]. If the database already contains data
+   associated with [key], raise [Dbm_error "Entry already exists"]. *)
+
+external replace : t -> string -> string -> unit = "caml_dbm_replace"
+(** [replace db key data] inserts the pair ([key], [data]) in
+   the database [db]. If the database already contains data
+   associated with [key], that data is discarded and silently
+   replaced by the new [data]. *)
+
+external remove : t -> string -> unit = "caml_dbm_delete"
+(** [remove db key data] removes the data associated with [key]
+   in [db]. If [key] has no associated data, raise
+   [Dbm_error "dbm_delete"]. *)
+
+external firstkey : t -> string = "caml_dbm_firstkey"
+(** See {!Dbm.nextkey}.*)
+
+external nextkey : t -> string = "caml_dbm_nextkey"
+(** Enumerate all keys in the given database, in an unspecified order.
+   [firstkey db] returns the first key, and repeated calls
+   to [nextkey db] return the remaining keys. [Not_found] is raised
+   when all keys have been enumerated. *)
+
+val iter : (string -> string -> 'a) -> t -> unit
+(** [iter f db] applies [f] to each ([key], [data]) pair in
+   the database [db]. [f] receives [key] as first argument
+   and [data] as second argument. *)
+(***********************************************************************)
+(*                                                                     *)
+(*                                CamlDBM                              *)
+(*                                                                     *)
+(*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        *)
+(*                                                                     *)
+(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
+(*  en Automatique.  All rights reserved.  This file is distributed    *)
+(*  under the terms of the GNU Library General Public License, with    *)
+(*  the special exception on linking described in file ../../LICENSE.  *)
+(*                                                                     *)
+(***********************************************************************)
+
+let optfind d k = try Some(Dbm.find d k) with Not_found -> None
+
+let _ =
+  let db = Dbm.opendbm "testdatabase" [Dbm.Dbm_rdwr;Dbm.Dbm_create] 0o666 in
+  Dbm.add db "one" "un";
+  Dbm.add db "two" "dos";
+  Dbm.replace db "two" "deux";
+  Dbm.add db "three" "trois";
+  assert (optfind db "one" = Some "un");
+  assert (optfind db "two" = Some "deux");
+  assert (optfind db "three" = Some "trois");
+  assert (optfind db "four" = None);
+  Dbm.close db;
+  let db = Dbm.opendbm "testdatabase" [Dbm.Dbm_rdonly] 0 in
+  Dbm.iter (fun k d -> Printf.printf "key '%s' -> data '%s'\n" k d) db;
+  Dbm.close db
+
+
+  
+